# AWS::DataBrew Construct Library

This module is part of the [AWS Cloud Development Kit](https://github.com/aws/aws-cdk) project.

```ts
import * as databrew from 'aws-cdk-lib/aws-databrew';
```

There are no official hand-written ([L2](https://docs.aws.amazon.com/cdk/latest/guide/constructs.html#constructs_lib)) constructs for this service yet. Here are some suggestions on how to proceed:

- Search [Construct Hub for DataBrew construct libraries](https://constructs.dev/search?q=databrew)
- Use the automatically generated [L1](https://docs.aws.amazon.com/cdk/latest/guide/constructs.html#constructs_l1_using) constructs, in the same way you would use [the CloudFormation AWS::DataBrew resources](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/AWS_DataBrew.html) directly.

There are no hand-written ([L2](https://docs.aws.amazon.com/cdk/latest/guide/constructs.html#constructs_lib)) constructs for this service yet.
However, you can still use the automatically generated [L1](https://docs.aws.amazon.com/cdk/latest/guide/constructs.html#constructs_l1_using) constructs, and use this service exactly as you would using CloudFormation directly.

For more information on the resources and properties available for this service, see the [CloudFormation documentation for AWS::DataBrew](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/AWS_DataBrew.html).

(Read the [CDK Contributing Guide](https://github.com/aws/aws-cdk/blob/main/CONTRIBUTING.md) and submit an RFC if you are interested in contributing to this construct library.)

## Types

| Name | Kind | Summary |
| --- | --- | --- |
| [`CfnDataset`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset) | Construct (L1) | Specifies a new DataBrew dataset. |
| [`CfnJob`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob) | Construct (L1) | Specifies a new DataBrew job. |
| [`CfnProject`](/v2/docs/aws-cdk-lib.aws_databrew.CfnProject) | Construct (L1) | Specifies a new AWS Glue DataBrew project. |
| [`CfnRecipe`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRecipe) | Construct (L1) | Specifies a new AWS Glue DataBrew transformation recipe. |
| [`CfnRuleset`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRuleset) | Construct (L1) | Specifies a new ruleset that can be used in a profile job to validate the data quality of a dataset. |
| [`CfnSchedule`](/v2/docs/aws-cdk-lib.aws_databrew.CfnSchedule) | Construct (L1) | Specifies a new schedule for one or more AWS Glue DataBrew jobs. |
| [`CfnDataset.CsvOptionsProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.CsvOptionsProperty) | Struct | Represents a set of options that define how DataBrew will read a comma-separated value (CSV) file when creating a dataset from that file. |
| [`CfnDataset.DatabaseInputDefinitionProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.DatabaseInputDefinitionProperty) | Struct | Connection information for dataset input files stored in a database. |
| [`CfnDataset.DataCatalogInputDefinitionProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.DataCatalogInputDefinitionProperty) | Struct | Represents how metadata stored in the AWS Glue Data Catalog is defined in a DataBrew dataset. |
| [`CfnDataset.DatasetParameterProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.DatasetParameterProperty) | Struct | Represents a dataset paramater that defines type and conditions for a parameter in the Amazon S3 path of the dataset. |
| [`CfnDataset.DatetimeOptionsProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.DatetimeOptionsProperty) | Struct | Represents additional options for correct interpretation of datetime parameters used in the Amazon S3 path of a dataset. |
| [`CfnDataset.ExcelOptionsProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.ExcelOptionsProperty) | Struct | Represents a set of options that define how DataBrew will interpret a Microsoft Excel file when creating a dataset from that file. |
| [`CfnDataset.FilesLimitProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.FilesLimitProperty) | Struct | Represents a limit imposed on number of Amazon S3 files that should be selected for a dataset from a connected Amazon S3 path. |
| [`CfnDataset.FilterExpressionProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.FilterExpressionProperty) | Struct | Represents a structure for defining parameter conditions. |
| [`CfnDataset.FilterValueProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.FilterValueProperty) | Struct | Represents a single entry in the `ValuesMap` of a `FilterExpression` . |
| [`CfnDataset.FormatOptionsProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.FormatOptionsProperty) | Struct | Represents a set of options that define the structure of either comma-separated value (CSV), Excel, or JSON input. |
| [`CfnDataset.InputProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.InputProperty) | Struct | Represents information on how DataBrew can find data, in either the AWS Glue Data Catalog or Amazon S3. |
| [`CfnDataset.JsonOptionsProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.JsonOptionsProperty) | Struct | Represents the JSON-specific options that define how input is to be interpreted by AWS Glue DataBrew . |
| [`CfnDataset.MetadataProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.MetadataProperty) | Struct | Contains additional resource information needed for specific datasets. |
| [`CfnDataset.PathOptionsProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.PathOptionsProperty) | Struct | Represents a set of options that define how DataBrew selects files for a given Amazon S3 path in a dataset. |
| [`CfnDataset.PathParameterProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.PathParameterProperty) | Struct | Represents a single entry in the path parameters of a dataset. |
| [`CfnDataset.S3LocationProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDataset.S3LocationProperty) | Struct | Represents an Amazon S3 location (bucket name, bucket owner, and object key) where DataBrew can read input data, or write output from a job. |
| [`CfnDatasetProps`](/v2/docs/aws-cdk-lib.aws_databrew.CfnDatasetProps) | Struct | Properties for defining a `CfnDataset`. |
| [`CfnJob.AllowedStatisticsProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.AllowedStatisticsProperty) | Struct | Configuration of statistics that are allowed to be run on columns that contain detected entities. |
| [`CfnJob.ColumnSelectorProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.ColumnSelectorProperty) | Struct | Selector of a column from a dataset for profile job configuration. |
| [`CfnJob.ColumnStatisticsConfigurationProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.ColumnStatisticsConfigurationProperty) | Struct | Configuration for column evaluations for a profile job. |
| [`CfnJob.CsvOutputOptionsProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.CsvOutputOptionsProperty) | Struct | Represents a set of options that define how DataBrew will write a comma-separated value (CSV) file. |
| [`CfnJob.DatabaseOutputProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.DatabaseOutputProperty) | Struct | Represents a JDBC database output object which defines the output destination for a DataBrew recipe job to write into. |
| [`CfnJob.DatabaseTableOutputOptionsProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.DatabaseTableOutputOptionsProperty) | Struct | Represents options that specify how and where DataBrew writes the database output generated by recipe jobs. |
| [`CfnJob.DataCatalogOutputProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.DataCatalogOutputProperty) | Struct | Represents options that specify how and where in the AWS Glue Data Catalog DataBrew writes the output generated by recipe jobs. |
| [`CfnJob.EntityDetectorConfigurationProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.EntityDetectorConfigurationProperty) | Struct | Configuration of entity detection for a profile job. |
| [`CfnJob.JobSampleProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.JobSampleProperty) | Struct | A sample configuration for profile jobs only, which determines the number of rows on which the profile job is run. |
| [`CfnJob.OutputFormatOptionsProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.OutputFormatOptionsProperty) | Struct | Represents a set of options that define the structure of comma-separated (CSV) job output. |
| [`CfnJob.OutputLocationProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.OutputLocationProperty) | Struct | The location in Amazon S3 or AWS Glue Data Catalog where the job writes its output. |
| [`CfnJob.OutputProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.OutputProperty) | Struct | Represents options that specify how and where in Amazon S3 DataBrew writes the output generated by recipe jobs or profile jobs. |
| [`CfnJob.ProfileConfigurationProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.ProfileConfigurationProperty) | Struct | Configuration for profile jobs. |
| [`CfnJob.RecipeProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.RecipeProperty) | Struct | Represents one or more actions to be performed on a DataBrew dataset. |
| [`CfnJob.S3LocationProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.S3LocationProperty) | Struct | Represents an Amazon S3 location (bucket name, bucket owner, and object key) where DataBrew can read input data, or write output from a job. |
| [`CfnJob.S3TableOutputOptionsProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.S3TableOutputOptionsProperty) | Struct | Represents options that specify how and where DataBrew writes the Amazon S3 output generated by recipe jobs. |
| [`CfnJob.StatisticOverrideProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.StatisticOverrideProperty) | Struct | Override of a particular evaluation for a profile job. |
| [`CfnJob.StatisticsConfigurationProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.StatisticsConfigurationProperty) | Struct | Configuration of evaluations for a profile job. |
| [`CfnJob.ValidationConfigurationProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJob.ValidationConfigurationProperty) | Struct | Configuration for data quality validation. |
| [`CfnJobProps`](/v2/docs/aws-cdk-lib.aws_databrew.CfnJobProps) | Struct | Properties for defining a `CfnJob`. |
| [`CfnProject.SampleProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnProject.SampleProperty) | Struct | Represents the sample size and sampling type for DataBrew to use for interactive data analysis. |
| [`CfnProjectProps`](/v2/docs/aws-cdk-lib.aws_databrew.CfnProjectProps) | Struct | Properties for defining a `CfnProject`. |
| [`CfnRecipe.ActionProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRecipe.ActionProperty) | Struct | Represents a transformation and associated parameters that are used to apply a change to an AWS Glue DataBrew dataset. |
| [`CfnRecipe.ConditionExpressionProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRecipe.ConditionExpressionProperty) | Struct | Represents an individual condition that evaluates to true or false. |
| [`CfnRecipe.DataCatalogInputDefinitionProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRecipe.DataCatalogInputDefinitionProperty) | Struct | Represents how metadata stored in the AWS Glue Data Catalog is defined in a DataBrew dataset. |
| [`CfnRecipe.InputProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRecipe.InputProperty) | Struct | Represents information on how DataBrew can find data, in either the AWS Glue Data Catalog or Amazon S3. |
| [`CfnRecipe.RecipeParametersProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRecipe.RecipeParametersProperty) | Struct | Parameters that are used as inputs for various recipe actions. |
| [`CfnRecipe.RecipeStepProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRecipe.RecipeStepProperty) | Struct | Represents a single step from a DataBrew recipe to be performed. |
| [`CfnRecipe.S3LocationProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRecipe.S3LocationProperty) | Struct | Represents an Amazon S3 location (bucket name, bucket owner, and object key) where DataBrew can read input data, or write output from a job. |
| [`CfnRecipe.SecondaryInputProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRecipe.SecondaryInputProperty) | Struct | Represents secondary inputs in a UNION transform. |
| [`CfnRecipeProps`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRecipeProps) | Struct | Properties for defining a `CfnRecipe`. |
| [`CfnRuleset.ColumnSelectorProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRuleset.ColumnSelectorProperty) | Struct | Selector of a column from a dataset for profile job configuration. |
| [`CfnRuleset.RuleProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRuleset.RuleProperty) | Struct | Represents a single data quality requirement that should be validated in the scope of this dataset. |
| [`CfnRuleset.SubstitutionValueProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRuleset.SubstitutionValueProperty) | Struct | A key-value pair to associate an expression's substitution variable names with their values. |
| [`CfnRuleset.ThresholdProperty`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRuleset.ThresholdProperty) | Struct | The threshold used with a non-aggregate check expression. |
| [`CfnRulesetProps`](/v2/docs/aws-cdk-lib.aws_databrew.CfnRulesetProps) | Struct | Properties for defining a `CfnRuleset`. |
| [`CfnScheduleProps`](/v2/docs/aws-cdk-lib.aws_databrew.CfnScheduleProps) | Struct | Properties for defining a `CfnSchedule`. |
